﻿using System;
using Sdl.FileTypeSupport.Framework.NativeApi;

namespace CustomWordCounter.Content
{
    public class Helper
    {
        /// <summary>
        /// Simple helper to recover the type of translation origin
        /// </summary>
        /// <param name="translationOrigin"></param>
        /// <returns></returns>
        public static string GetOriginType(ITranslationOrigin translationOrigin)
        {
            if (translationOrigin == null)
                return "New";

            if (string.Compare(translationOrigin.OriginType, "auto-propagated", StringComparison.OrdinalIgnoreCase) == 0)
            {
                return "Repetition";
            }
            if (string.Compare(translationOrigin.OriginType, "interactive", StringComparison.OrdinalIgnoreCase) == 0)
            {
                return "New";
            }

            if (translationOrigin.MatchPercent >= 100)
            {
                if (string.Compare(translationOrigin.OriginType, "document-match", StringComparison.OrdinalIgnoreCase) == 0)
                {
                    return "PerfectMatch";
                }
                if (translationOrigin.TextContextMatchLevel == TextContextMatchLevel.SourceAndTarget)
                {
                    return "Context Match";
                }
                if (string.Compare(translationOrigin.OriginType, "amt", StringComparison.OrdinalIgnoreCase) == 0)
                {
                    return "AdaptiveMT";
                }
                return string.Compare(translationOrigin.OriginType, "mt", StringComparison.OrdinalIgnoreCase) == 0 ? "AT" : "100%";
            }
            if (string.Compare(translationOrigin.OriginType, "amt", StringComparison.OrdinalIgnoreCase) == 0)
            {
                return "AdaptiveMT";
            }
            if (string.Compare(translationOrigin.OriginType, "mt", StringComparison.OrdinalIgnoreCase) == 0)
            {
                return "AT";
            }
            if (translationOrigin.MatchPercent > 0)
            {
                // return a static range for this example
                if (translationOrigin.MatchPercent >= 95 && translationOrigin.MatchPercent <= 99)
                    return "95% - 99%";
                if (translationOrigin.MatchPercent >= 85 && translationOrigin.MatchPercent <= 94)
                    return "85% - 94%";
                if (translationOrigin.MatchPercent >= 75 && translationOrigin.MatchPercent <= 84)
                    return "75% - 84%";
                if (translationOrigin.MatchPercent >= 50 && translationOrigin.MatchPercent <= 74)
                    return "50% - 74%";
                return "New";
            }

            return "New";
        }


    }
}
